/* 
The game logic.
*/

#pragma once
#include <string>

// to make syntax Unreal friendly
using int32 = int;
using FString = std::string;

struct FBullCowCount
{
	int32 Bulls = 0;
	int32 Cows = 0;
};

enum EGuessStatus
{
	Invalid_Status,
	OK,
	Not_Isogram,
	Wrong_Length,
	Not_Lowercase,
	Is_Empty,
	Have_Digits,
	Have_Punctuation,
	Have_Space
};

class FBUllCowGame {
public:
	FBUllCowGame(); //constructor

	int32 GetMaxTries() const;
	int32 GetCurrentTry() const;
	int32 GetHiddenWordLength() const;
	FString GetHintForHiddenWord() const;
	bool IsGameWon() const;

	void InitializeWord(FString WordLength);
	
	EGuessStatus CheckGuessValidity(FString Guess) const;
	// counts for bulls and cows, and incr turn # assuming valid guess
	void Reset();
	FBullCowCount SubmitValidGuess(FString);
private:
	//see constructor for initialization
	int32 MyCurrentTry;
	//int32 MyMaxTries;
	FString MyHiddenWord;
	bool bGameIsWon;
	FString HintForWord;
	
	bool IsIsogram(FString Word) const;
	bool IsLowerCase(FString Word) const;
	bool IsHaveDigits(FString Word) const;
	bool IsHavePunctuation(FString Word) const;
	bool IsHaveSpace(FString Word) const;
};
